*Create the design matrix of contrast coefficients for a 2^4 design;
data xmatrix16;
do x4=-1 to 1 by 2;
 do x3=-1 to 1 by 2;
  do x2=-1 to 1 by 2;
   do x1=-1 to 1 by 2;
   I=1; A=x1; B=x2; C=x3; D=x4; 
   AB=A*B; AC=A*C; AD=A*D; BC=B*C; BD=B*D; CD=C*D;
   ABC=A*B*C; ABD=A*B*D; ACD=A*C*D; BCD=B*C*D; ABCD=A*B*C*D;
   output;
   end;
  end;
 end;
end;
drop x1-x4;
run;
*Read in the response data for 2^4 design;
data boxmey;
input y @@;
datalines;
47.46 49.62 43.13 46.31 51.47 48.49 49.34 46.10 46.76 48.56 44.83 44.45 
59.15 51.33 47.02 47.90
*Defines the nobs and vname1 macro variables needed by the macro;
%let nobs=16;
%let vname1={'I' 'A' 'B' 'C' 'D'
'AB' 'AC' 'AD' 'BC' 'BD' 'CD'
'ABC' 'ABD' 'ACD' 'BCD' 'ABCD'};
*Invokes the macro;
data y; set boxmey;
data x1; set xmatrix16;
%gapmth
